<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2008 Mandriva, http://www.mandriva.com/
 *
 * $Id$
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

require("modules/samba/includes/shares.inc.php");
require("modules/samba/includes/samba.inc.php");

if (isset($_POST["brestart"])) {
    header("Location: " . urlStrRedirect("samba/config/restart"));
    exit;
} else if (isset($_POST["breload"])) {
    header("Location: " . urlStrRedirect("samba/config/reload"));
    exit;    
}

function get_smbconf() {
    $smbInfo = xmlCall("samba.getSmbInfo", null);
    return $smbInfo;
}

function check_authorizedPathsExist($paths) {
    $missing = xmlCall("samba.checkAuthorizedPathsExist", array($paths));
    return $missing;
}

function save_smbconf() {
    $options = array();

    #sanitize POST values
    foreach ($_POST as $key => $value)
        $options[str_replace("_", " ", $key)] = stripslashes($value);
    if(!isset($_POST['hasprofiles']))
        $options['hasprofiles'] = false;
    else
        $options['hasprofiles'] = true;
    if(!isset($_POST['hashomes']))
        $options['hashomes'] = false;
    else
        $options['hashomes'] = true;
    if(!isset($_POST['pdc']))
        $options['pdc'] = false;
    else
        $options['pdc'] = true;

    $authorizedSharePaths = array_unique($_POST["authorizedSharePaths"]);
    $options['authorizedSharePaths'] = implode(",", $authorizedSharePaths);

    # apply samba options
    return xmlCall("samba.smbInfoSave", array($options));
}

function getCheckedState($smb, $option) {
    $ret = "";
    if (strtolower($smb[$option]) == "yes")
        $ret = "checked";
    return $ret;
}


if (isset($_POST["bsave"])) {
    $authorizedSharePaths = array_unique($_POST["authorizedSharePaths"]);
    for ($i = 0; $i < count($authorizedSharePaths); $i++) {
        if (substr($authorizedSharePaths[$i], -1) == "/") {
            $error.=_T("Trailing / is not allowed in authorized share paths");
        }
    }
    if (!isset($error)) {                                    
	$missing = check_authorizedPathsExist($authorizedSharePaths);
	if ($missing) {
    	    setFormError("authorizedSharePaths");
	    $error = _T("The authorized share paths do not exist: ").implode(",", $missing);
	} else {
	    $ret = save_smbconf();
	    if (!isXMLRPCError()) {
    		new NotifyWidgetSuccess(sprintf(_T("SAMBA configuration saved. You may need to reload or restart the SAMBA service.")));
	    }
	}    
    }
    if (isset($error))
    new NotifyWidgetFailure($error);
}

require("modules/samba/mainSidebar.php");
require("graph/navbar.inc.php");

if (isset($_POST["bsave"])) {
    $workgroup = $_POST["workgroup"];
    $netbios_name = $_POST["netbios_name"];
    if (!isset($_POST["pdc"]))
        $pdc = false;
    else
        $pdc = true;
    if (!isset($_POST["wins_support"]))
        $wins = "no";
    else
        $wins = "yes";
    if (!isset($_POST["hashomes"]))
        $hashomes = false;
    else
        $hashomes = true;
    $logon_path = $_POST["logon_path"];
    $ldap_passwd_sync = $_POST["ldap_passwd_sync"];
    $logon_script = $_POST["logon_script"];
    $logon_home = $_POST["logon_home"];
    $logon_drive = $_POST["logon_drive"];
    $authorizedSharePaths = array_unique($_POST["authorizedSharePaths"]);
} else {
    $smb = get_smbconf();
    $workgroup = $smb["workgroup"];
    $netbios_name = $smb["netbios name"];
    $pdc = $smb["pdc"];
    
    if (!isset($smb["wins support"]))
        $wins = "no";
    else
        $wins = $smb["wins support"];
    if (!isset($smb['hashomes']))
        $hashones = false;
    else
	$hashomes = $smb["hashomes"];
    $logon_path = $smb["logon path"];
    if (!isset($smb["ldap passwd sync"]))
        $ldap_passwd_sync = "no";
    else
        $ldap_passwd_sync = $smb["ldap passwd sync"];
    
    $logon_script = $smb["logon script"];
    $logon_home = $smb["logon home"];
    $logon_drive = $smb["logon drive"];
    $authorizedSharePaths = array_unique($smb["authorizedSharePaths"]);
}

$p = new PageGenerator(_T("General options"));
$p->setSideMenu($sidemenu);
$p->display();

$f = new ValidatingForm();
$f->push(new Table());

if ($pdc)
    $workgroupTpl = new HiddenTpl("workgroup");
else
    $workgroupTpl = new NetbiosUppercaseInputTpl("workgroup");

$f->add(
        new TrFormElement(_T("Domain name"), $workgroupTpl),
        array("value" => $workgroup, "required" => True)
);

$f->add(
        new TrFormElement(_T("Server name"), new NetbiosUppercaseInputTpl("netbios_name")),
        array("value" => $netbios_name, "required" => True)
);

$value = "";
if ($pdc) $value = "checked";
$f->add(
        new TrFormElement(_T("This server is a PDC"),new CheckboxTpl("pdc")),
        array("value" => $value)
);

$value = "";
if (strtolower($wins) == "yes") $value = "checked";
$f->add(
        new TrFormElement(_T("This server is a WINS server"),new CheckboxTpl("wins_support")),
        array("value" => $value)
);

$value = "";
if ($hashomes) $value = "checked";
$f->add(
        new TrFormElement(_T("Share user's homes"),new CheckboxTpl("hashomes")),
        array("value" => $value)
);

$value = "";
$hasProfiles = false;
if (isset($logon_path)) {
    $value = "checked"; 
    $hasProfiles = true;
}

$f->add(
        new TrFormElement(_T("Use network profiles for users"), new CheckboxTpl("hasprofiles"), 
            array("tooltip" => _T("Activate roaming profiles for all users.", "samba"))), 
        array("value" => $value, "extraArg" => 'onclick=toggleVisibility("profilespath")')
);

$f->pop();

$pathdiv = new Div(array("id" => "profilespath"));
$pathdiv->setVisibility($hasProfiles);

$f->push($pathdiv);
$f->push(new Table());

# default value for profile path
$value = "\\\\%N\\profiles\\%U";
if ($hasProfiles) $value = $logon_path;
$f->add(
        new TrFormElement(_T("Network path for profiles"), new InputTpl("logon_path"),
            array("tooltip" => _T("The share must exist and be world-writable.", "samba"))), 
        array("value" => $value)
);
$f->pop();
$f->pop();

$f->push(new DivExpertMode());
$f->push(new Table());

$syncTpl = new SelectItem("ldap_passwd_sync");
$labels = array(_T('Yes'), _T('No'), _T('Only (for smbk5pwd)'));
$values = array('yes', 'no', 'only');
$syncTpl->setElements($labels);
$syncTpl->setElementsVal($values);

$f->add(
        new TrFormElement(_T("LDAP password sync"), $syncTpl),
        array("value" => $ldap_passwd_sync)
);

$f->add(
        new TrFormElement(_T("Opening script session"), new IA5InputTpl("logon_script")),
        array("value" => $logon_script)
);

$f->add(
        new TrFormElement(_T("Base directory path"), new IA5InputTpl("logon_home")),
        array("value" => $logon_home)
);

$f->add(
        new TrFormElement(_T("Connect base directory on network drive"), new IA5InputTpl("logon_drive")),
        array("value" => $logon_drive)
);

$f->pop();
$f->pop();

$f->push(new DivExpertMode());

$authorizedSharePathsTpl = new MultipleInputTpl("authorizedSharePaths", _T("Authorized share paths"));
$f->add(
        new FormElement(_T("Authorized share paths"), $authorizedSharePathsTpl, array("tooltip" => _T("Authorized paths for share creation"))),
        $authorizedSharePaths
        
);

$f->pop();

$f->addValidateButton("bsave");
$f->addExpertButton("brestart", _T("Restart SAMBA"));
$f->addButton("breload", _T("Reload SAMBA configuration"));

$f->display();

?>
